function int = bin2int(binary,code)

%   Convert binary or gray codet binary to integer.
%   code;   0 = binary    |   1 = gray

if nargin < 2
    code=0;
end

[l,n] = size(binary);
bin = zeros(l,n);

if code
    bin(:,1) = binary(:,1);
    for i = 2:n
        bin(:,i) = xor(bin(:,i-1),binary(:,i));
    end
else
    bin=binary;
end


map = 2 .^ (n-1:-1:0);
map = map(ones(l,1),:);
int = abs(sum(map.*bin,2));
