function call_Osiris(nRuns,filesize)

% This function performes the actual call to the forward model OSIRIS. 
% 4 models can be calculated simultanously.
% The input is: 
% nRuns = the number of new individuals or the number of calls which
% has to be made
% filesize = the size of observed.out. Used to check that the new output
% files are the same size before a new call is made

for  z = 1:4:nRuns
    pause(1)
    fprintf('Processing model %d of %d \n', z, nRuns);
    unix(['sgaosiris* model_', num2str(z, '%3.2d'), '.pre &']);
    pause(0.5)
    fprintf('Processing model %d of %d \n', z+1, nRuns);
    unix(['sgaosiris* model_', num2str(z+1, '%3.2d'), '.pre &']);
    pause(0.5)
    fprintf('Processing model %d of %d \n', z+2, nRuns);    
    unix(['sgaosiris* model_', num2str(z+2, '%3.2d'), '.pre &']);
    pause(0.5)
    fprintf('Processing model %d of %d \n', z+3, nRuns);    
    unix(['sgaosiris* model_', num2str(z+3, '%3.2d'), '.pre']);
    
    file1 = dir(['model_', num2str(z, '%3.2d'), '.out']);
    file2 = dir(['model_', num2str(z+1, '%3.2d'), '.out']);
    file3 = dir(['model_', num2str(z+2, '%3.2d'), '.out']);
    tot_size = file1.bytes + file2.bytes + file3.bytes;
    if tot_size < (3*filesize)  % Make sure all the calculating is done before proceeding
        while 1
            fprintf('Wainting for OSIRIS...\n');
            pause(0.5);
            file1 = dir(['model_', num2str(z, '%3.2d'), '.out']);
            file2 = dir(['model_', num2str(z+1, '%3.2d'), '.out']);
            file3 = dir(['model_', num2str(z+2, '%3.2d'), '.out']);
            tot_size = file1.bytes + file2.bytes + file3.bytes;
            if tot_size >= (3*filesize)
                break
            end
        end
    end
end
