% Plot parameters and 20 best found during inversion
close all;
scrsz = get(0,'ScreenSize');
set(figure(2),'Position',[1 -50 scrsz(3) round(scrsz(4)/1.1)]);

k=0;
for j = 1:nParm
    for l = 1:nlayers
        k = k + 1;
        switch (inv_parameters(j,:))
            case ('Vp')
                label{k} = ['P-vel. ', num2str(l)];
                %obs(k) = model_matrix(2+l,3);
                obs(k) = model_matrix(1+l,3);
            case ('Vs')
                label{k} = ['S-vel. ', num2str(l)];
                %obs(k) = model_matrix(2+l,4);
                obs(k) = model_matrix(1+l,4);
            case ('ap')
                label{k} = ['P-att. ', num2str(l),];
                obs(k) = model_matrix(2+l,5);
            case ('as')
                label{k} = ['S-att. ', num2str(l)];
                obs(k) = model_matrix(2+l,6);
            case ('de')
                label{k} = ['Density ', num2str(l)];
                %obs(k) = model_matrix(2+l,7);
                obs(k) = model_matrix(1+l,2);
            case ('ti')
                label{k} = ['Layer thickness ', num2str(l)];
                %obs(k) = model_matrix((2+l),2)- model_matrix((1+l),2);
                if l<(nlayers-1)
                    obs(k) = model_matrix((2+l),1)- model_matrix((1+l),1);
                else
                    obs(k) =obs(k-1);
                end
        end
    end
end
obs=obs.*1000;
ymin = min(min_phen)*0.99;
ymax = max(min_phen)*1.01;

if nPar <= 10;
    H=1;
    V=nPar;
else
    H=2;
    V=ceil(nPar/2);
end

if length(label) < nPar
    nPar1=nPar;
    nPar=length(label);
end

%title('20 best models found during optimization')
for i=1:nPar
    subplot(V,H,i);
    hold on; plot(min_phen(:,i));
    plot(obs(i)*ones(1,gen), ':k');
    hold off;
    xlim([0 ceil(gen*1.2)]);
    ylim([ymin(i) ymax(i)]);
    text(0.5,0.8,['Final = ', num2str(min_phen(end,i))],'Units','normalized');
    title(label{i}); 
end

pause(0.1)
plot_best(BestPhen, nlayers, inv_parameters, scrsz,1);
drawnow



% for i=1:nPar
%     figure(4)
%     s=0:1;
%     A = BestPhen(:,i)*ones(1,2);
%     subplot(V,H,i); plot(A,s);
%     
% end
    


