function varargout = forwparamTHM(varargin)
% FORWPARAMTHM M-file for forwparamTHM.fig
%      FORWPARAMTHM, by itself, creates a new FORWPARAMTHM or raises the existing
%      singleton*.
%
%      H = FORWPARAMTHM returns the handle to a new FORWPARAMTHM or the handle to
%      the existing singleton*.
%
%      FORWPARAMTHM('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FORWPARAMTHM.M with the given input arguments.
%
%      FORWPARAMTHM('Property','Value',...) creates a new FORWPARAMTHM or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before forwparamTHM_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to forwparamTHM_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help forwparamTHM

% Last Modified by GUIDE v2.5 13-Mar-2007 15:32:07

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @forwparamTHM_OpeningFcn, ...
                   'gui_OutputFcn',  @forwparamTHM_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before forwparamTHM is made visible.
function forwparamTHM_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to forwparamTHM (see VARARGIN)

        min_freq = 3;
        max_freq = 25;
        freq_step = .5;
        Vp_min=100;  % Lower limit on interesting phase velocities [m/s]
        Vp_max=1000;  % Higher limit on interesting phase velocities m/s]
        Vp_step=1; % Steps in phase velocity
        Root_Tol=.001; % Root tolerance for forward model
        MXiterations=100; % Maximum number of iterations in forward model
        NumberModes =1;
        
        set(handles.min_freq,'String',min_freq);
        set(handles.max_freq,'String',max_freq);
        set(handles.freq_step,'String',freq_step);
        set(handles.Vp_min,'String',Vp_min);
        set(handles.Vp_max,'String',Vp_max);
        set(handles.Vp_step,'String',Vp_step);
        set(handles.Root_Tol, 'String', Root_Tol);
        set(handles.MXiterations, 'String', MXiterations);
        set(handles.NumberModes, 'String', NumberModes);
        
        handles.min_freq = min_freq;
        handles.max_freq = max_freq;
        handles.freq_step = freq_step;
        handles.Vp_min=Vp_min;  % Lower limit on interesting phase velocities [km/s]
        handles.Vp_max=Vp_max;  % Higher limit on interesting phase velocities [km/s]
        handles.Vp_step=Vp_step; % Steps in phase velocity
        handles.Root_Tol=Root_Tol;
        handles.MXiterations=MXiterations;
        handles.NumberModes =NumberModes;
        


% Choose default command line output for forwparamTHM
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes forwparamTHM wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = forwparamTHM_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function min_freq_Callback(hObject, eventdata, handles)
% hObject    handle to min_freq (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of min_freq as text
%        str2double(get(hObject,'String')) returns contents of min_freq as a double

min_freq = str2double(get(hObject, 'String'));
if isnan(min_freq)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.min_freq = min_freq;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function min_freq_CreateFcn(hObject, eventdata, handles)
% hObject    handle to min_freq (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function max_freq_Callback(hObject, eventdata, handles)
% hObject    handle to max_freq (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of max_freq as text
%        str2double(get(hObject,'String')) returns contents of max_freq as a double

max_freq = str2double(get(hObject, 'String'));
if isnan(max_freq)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.max_freq = max_freq;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function max_freq_CreateFcn(hObject, eventdata, handles)
% hObject    handle to max_freq (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function freq_step_Callback(hObject, eventdata, handles)
% hObject    handle to freq_step (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of freq_step as text
%        str2double(get(hObject,'String')) returns contents of freq_step as a double

freq_step = str2double(get(hObject, 'String'));
if isnan(freq_step)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.freq_step = freq_step;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function freq_step_CreateFcn(hObject, eventdata, handles)
% hObject    handle to freq_step (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Vp_min_Callback(hObject, eventdata, handles)
% hObject    handle to Vp_min (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Vp_min as text
%        str2double(get(hObject,'String')) returns contents of Vp_min as a double

Vp_min = str2double(get(hObject, 'String'));
if isnan(Vp_min)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.Vp_min = Vp_min;
guidata(hObject,handles)


% --- Executes during object creation, after setting all properties.
function Vp_min_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Vp_min (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Vp_max_Callback(hObject, eventdata, handles)
% hObject    handle to Vp_max (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Vp_max as text
%        str2double(get(hObject,'String')) returns contents of Vp_max as a double

Vp_max = str2double(get(hObject, 'String'));
if isnan(Vp_max)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.Vp_max = Vp_max;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function Vp_max_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Vp_max (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Vp_step_Callback(hObject, eventdata, handles)
% hObject    handle to Vp_step (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Vp_step as text
%        str2double(get(hObject,'String')) returns contents of Vp_step as a double

Vp_step = str2double(get(hObject, 'String'));
if isnan(Vp_step)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.Vp_step = Vp_step;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function Vp_step_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Vp_step (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Root_Tol_Callback(hObject, eventdata, handles)
% hObject    handle to Root_Tol (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Root_Tol as text
%        str2double(get(hObject,'String')) returns contents of Root_Tol as a double

Root_Tol = str2double(get(hObject, 'String'));
if isnan(Root_Tol)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.Root_Tol = Root_Tol;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function Root_Tol_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Root_Tol (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function MXiterations_Callback(hObject, eventdata, handles)
% hObject    handle to MXiterations (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of MXiterations as text
%        str2double(get(hObject,'String')) returns contents of MXiterations as a double

MXiterations = str2double(get(hObject, 'String'));
if isnan(MXiterations)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.MXiterations = MXiterations;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function MXiterations_CreateFcn(hObject, eventdata, handles)
% hObject    handle to MXiterations (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function NumberModes_Callback(hObject, eventdata, handles)
% hObject    handle to NumberModes (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of NumberModes as text
%        str2double(get(hObject,'String')) returns contents of NumberModes as a double

NumberModes = str2double(get(hObject, 'String'));
if isnan(NumberModes)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.NumberModes = NumberModes;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function NumberModes_CreateFcn(hObject, eventdata, handles)
% hObject    handle to NumberModes (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on button press in fine.
function fine_Callback(hObject, eventdata, handles)
% hObject    handle to fine (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

        min_freq=handles.min_freq  ;
        max_freq = handles.max_freq;
        freq_step = handles.freq_step;
        Vp_min=handles.Vp_min./1000;  % Lower limit on interesting phase velocities [km/s]
        Vp_max=handles.Vp_max./1000;  % Higher limit on interesting phase velocities [km/s]
        Vp_step=handles.Vp_step./1000; % Steps in phase velocity
        Root_Tol=handles.Root_Tol;
        MXiterations=handles.MXiterations;
        NumberModes =handles.NumberModes;

        save paramTHM min_freq max_freq freq_step Vp_min Vp_max Vp_step Root_Tol MXiterations NumberModes

delete(handles.figure1)
