function varargout = genvar(varargin)
% GENVAR M-file for genvar.fig
%      GENVAR, by itself, creates a new GENVAR or raises the existing
%      singleton*.
%
%      H = GENVAR returns the handle to a new GENVAR or the handle to
%      the existing singleton*.
%
%      GENVAR('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GENVAR.M with the given input arguments.
%
%      GENVAR('Property','Value',...) creates a new GENVAR or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before genvar_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to genvar_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help genvar

% Last Modified by GUIDE v2.5 04-May-2007 12:43:57

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @genvar_OpeningFcn, ...
                   'gui_OutputFcn',  @genvar_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before genvar is made visible.
function genvar_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to genvar (see VARARGIN)

popsize=56;
maxgen=100;
pcross=0.8;
pmutate=0.05;
gengap=0.5;

set(handles.popsize,'String',int2str(popsize));
set(handles.maxgen,'String',int2str(maxgen));
% set(handles.pcross,'String',int2str(pcross));
% set(handles.pmutate,'String',int2str(pmutate));
% set(handles.gengap,'String',int2str(gengap));

handles.popsize=popsize;
handles.maxgen=maxgen;
handles.pcross=pcross;
handles.pmutate=pmutate;
handles.gengap=gengap;

% Choose default command line output for genvar
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes genvar wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = genvar_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function popsize_Callback(hObject, eventdata, handles)
% hObject    handle to popsize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of popsize as text
%        str2double(get(hObject,'String')) returns contents of popsize as a double


% --- Executes during object creation, after setting all properties.
function popsize_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popsize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function maxgen_Callback(hObject, eventdata, handles)
% hObject    handle to maxgen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of maxgen as text
%        str2double(get(hObject,'String')) returns contents of maxgen as a double

maxgen = str2double(get(hObject, 'String'));
if isnan(maxgen)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

handles.maxgen = maxgen;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function maxgen_CreateFcn(hObject, eventdata, handles)
% hObject    handle to maxgen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function pcross_Callback(hObject, eventdata, handles)
% hObject    handle to pcross (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of pcross as text
%        str2double(get(hObject,'String')) returns contents of pcross as a double

pcross = str2double(get(hObject, 'String'));
if isnan(pcross)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

handles.pcross = pcross;
guidata(hObject,handles)


% --- Executes during object creation, after setting all properties.
function pcross_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pcross (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function pmutate_Callback(hObject, eventdata, handles)
% hObject    handle to pmutate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of pmutate as text
%        str2double(get(hObject,'String')) returns contents of pmutate as a double

pmutate = str2double(get(hObject, 'String'));
if isnan(pmutate)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

handles.pmutate = pmutate;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function pmutate_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pmutate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gengap_Callback(hObject, eventdata, handles)
% hObject    handle to gengap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gengap as text
%        str2double(get(hObject,'String')) returns contents of gengap as a double

gengap = str2double(get(hObject, 'String'));
if isnan(gengap)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

handles.gengap = gengap;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function gengap_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gengap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in fine.
function fine_Callback(hObject, eventdata, handles)
% hObject    handle to fine (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

popsize=handles.popsize;
maxgen=handles.maxgen;
pcross=handles.pcross;
pmutate=handles.pmutate;
gengap=handles.gengap;

save genvariables popsize maxgen pcross pmutate gengap;

delete(handles.figure1)
