function [c, kval] = haskell(rho,alpha,betha,d,min_freq, max_freq, kstep, cmin, cmax, cstep) 


% rho = de, alpha = vp, betha = vs, d = ti
%Because I can't get the method to work with a fluid upper layer I remove
%the upper layer if it's fluid. (I now assume no other layers are fluid)

if betha(1) == 0
    rho = rho(2:end);
    alpha = alpha(2:end);
    betha = betha(2:end);
    d = d(2:end);
end
n = length(d);
%%% SETTING THE LIMITATIONS ON C AND K (OR OMEGA) %%%
% As you can see I've been trying different solutions to find which areas
% the variables has to bee in. When there is no fluid layer the phase
% speed is supposed to be between 87% of the lowest speed, and 95% of the
% highest speed.

% ncsteps = 100;
% % cmin = min(betha).*.87;
% % cmax = max(betha).*.95;
%  %cmin=400;
% % cmax=1400;
% cmin=100;
% cmax=600;
% cstep = (cmax-cmin)/(ncsteps-1);
%c = cmax:-cstep:cmin;
c=cmin:cstep:cmax;
ncsteps = length(c);

%k=omega./c; % The connection between the variables
%nksteps = 200;

 omega = (min_freq:kstep:max_freq).*2*pi;
 nksteps = length(omega);
%omega = (1:(90-1)/(nksteps-1):90);%.*2*pi;
% kmin = .005;
% kmax =.05;

%%% CALCULATING CONSTANTS DEPENDENT ON THE GIVEN VARIABLES %%%
[ra rb gamma] = variables(c, alpha, betha);

%%% THE MAIN LOOP %%%
kk=0;
for q = 1:ncsteps;
    %Setting the size of the a-matrix and making sure it's deleted between
    %each new round in the loop.
    a = zeros(4,nksteps,4,n);
    ct = c(q); %The c-value for which the corresponding k is found.
    % Making sure that ct is not like the shear speed of the first layer
    % since that might create problems.
    if ct==betha(1)
        ct=ct+ct.*.00001;
    end
   % k=logspace(log10(kmin),log10(kmax),nksteps); % This gives logaritmic
   % spacing between the variables, but I've removed it when I changed the
   % code to use omega as the limiting factor (in the initialization)
   k=omega./ct;
    [P Q] = P_Q(k,ra(:,q),rb(:,q),d);
    
    %%% FINDING THE A-MATRIX FOR EACH LAYER %%%
    for m=1:(n-1) %The bottom semi-infinite layer is not used here, the variables for that layer is inserted on a later stage

        if betha(m) == 0 %If one of the layers is wather this a is used
            %There is something wrong in this calculation. The amplitudes
            %in the end result becomes in the 1e100 order, which is not a
            %good thing.
            a(1,:,2,m) = - i .* sin(P(m,:)) ./ ra(m,q);
            a(1,:,3,m) = - cos(P(m,:)) ./ (rho(m) .* ct.^2);
            a(2,:,2,m) = cos(P(m,:));
            a(2,:,3,m) = i .* ra(m,q) .* sin(P(m,:)) ./ (rho(m) .* ct.^2);
            a(3,:,2,m) = i .* rho(m) .* ct.^2 .* sin(P(m,:)) ./ ra(m,q);
            a(3,:,3,m) = cos(P(m,:));
            %a_vann = a(:,:,:,m);
        else
            % The a-matrix calculation for solid layers

            a(1,:,1,m) = gamma(m,q) .* cos(P(m,:)) - (gamma(m,q) -1) .* cos(Q(m,:));
            a(1,:,2,m) = i.* ( ((gamma(m,q)-1) .* sin(P(m,:)) ./ ra(m,q)) + gamma(m,q) .* rb(m,q) .* sin(Q(m,:)) );
            a(1,:,3,m) = - (cos(P(m,:)) - cos(Q(m,:))) ./ (rho(m) .*ct.^2);
            a(1,:,4,m) = i .* ((sin(P(m,:)) ./ ra(m,q)) + rb(m,q) .* sin(Q(m,:))) ./ (rho(m) .*ct.^2);
            a(2,:,1,m) = - i .* ( gamma(m,q) .* ra(m,q) .* sin(P(m,:)) + ((gamma(m,q) -1) .* sin(Q(m,:)) ./ rb(m,q)) );
            a(2,:,2,m) = - (gamma(m,q) - 1) .* cos(P(m,:)) + gamma(m,q) .* cos(Q(m,:));
            a(2,:,3,m) = i .* (ra(m,q) .* sin(P(m,:)) + (sin(Q(m,:)) ./ rb(m,q))) ./ (rho(m) .*ct.^2);
            a(2,:,4,m) = a(1,:,3,m);
            a(3,:,1,m) = rho(m) .* ct.^2 .* gamma(m,q) .* (gamma(m,q) - 1) .* (cos(P(m,:)) - cos(Q(m,:)));
            a(3,:,2,m) = i .* rho(m) .* ct.^2 .* ( ((gamma(m,q) - 1).^2 .* sin(P(m,:)) ./ ra(m,q)) + gamma(m,q).^2 .* rb(m,q) .* sin(Q(m,:)) );
            a(3,:,3,m) = a(2,:,2,m);
            a(3,:,4,m) = a(1,:,2,m);
            a(4,:,1,m) = i .* rho(m) .* ct.^2 .* ( gamma(m,q).^2 .* ra(m,q) .* sin(P(m,:)) + ((gamma(m,q) - 1).^2 .* sin(Q(m,:)) ./ rb(m,q)));
            a(4,:,2,m) = a(3,:,1,m);
            a(4,:,3,m) = a(2,:,1,m);
            a(4,:,4,m) = a(1,:,1,m);
        end

    end

    %%% MATRIX MULTIPLICATION OF THE LAYERS %%%

    for p = 1:nksteps
        for s = 1:n-1
            if s == 1
                mellom = squeeze(a(:,p,:,s));
            else
                mellom = squeeze(a(:,p,:,s)) * mellom;
            end
        end
        A(:,p,:) = mellom;
    end 
    
    %%% DETERMINATION OF THE "DETERMINANT=0" %%%
    % The variables for the semi-infinite layer is added here.
    %There is something wrong with the reasoning when I fond the formula
    %used when we have water in the top layer because the amplitudes become
    %gigant.
    K = gamma(n,q) .* ra(n,q) .* A(1,:,2) + (gamma(n,q) - 1) .* A(2,:,2) - ra(n,q) .*A(3,:,2) ./ (rho(n) .* ct.^2) + A(4,:,2) ./(rho(n) .* ct.^2) ;
    M = -(gamma(n,q) - 1) .* A(1,:,2) + gamma(n,q) .* rb(n,q) .* A(2,:,2) + A(3,:,2) ./ (rho(n) .* ct.^2) + rb(n,q) .* A(4,:,2) ./ (rho(n) .* ct.^2);
    if betha(1) ~= 0 
        L = gamma(n,q) .* ra(n,q) .* A(1,:,1) + (gamma(n,q) - 1) .* A(2,:,1) - ra(n,q) .*A(3,:,1) ./ (rho(n) .* ct.^2) + A(4,:,1) ./(rho(n) .* ct.^2) ;
        N = -(gamma(n,q) - 1) .* A(1,:,1) + gamma(n,q) .* rb(n,q) .* A(2,:,1) + A(3,:,1) ./ (rho(n) .* ct.^2) + rb(n,q) .* A(4,:,1) ./ (rho(n) .* ct.^2);
        lign(q,:) = K./L - M./N;
    else
        lign(q,:) = K - M;
    end

%     [y,ind] = sort(abs(lign(q,:)),'descend');
%     [tull place] = min(y);
%     kplace = ind(place);

    [tull kplace] = min(abs(lign(q,:)));
    
    % The chosen k value for the given c
    kk(q) = k(kplace);
    %Saving these values for the figures
    %ktopp(q)=k(end);
    %klav(q)=k(1);
        
end

kval = kk;