function varargout = modell(varargin)
% MODELL M-file for modell.fig
%
%      *This GUI lets you write in the values for the geoacoustic model
%      used to produse the syntethic data. When you press the button
%      "Finished" the values will be stored in the file "geomodel.mat", and
%      the window will be closed.
%
%      MODELL, by itself, creates a new MODELL or raises the existing
%      singleton*.
%
%      H = MODELL returns the handle to a new MODELL or the handle to
%      the existing singleton*.
%
%      MODELL('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MODELL.M with the given input arguments.
%
%      MODELL('Property','Value',...) creates a new MODELL or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before modell_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to modell_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help modell

% Last Modified by GUIDE v2.5 01-Feb-2007 10:40:02

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @modell_OpeningFcn, ...
                   'gui_OutputFcn',  @modell_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before modell is made visible.
function modell_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to modell (see VARARGIN)

% SETTING INITIAL VALUES
tii = [50 50 50 inf]; % Thickness of the layer
vpi = [1500 1600 1800 2800]; % Pressure speed
vsi = [0 500 1000 1500]; % Shear speed
dei = [1000 1600 2000 2200]; % Density

ni = 4; % Number of layers

for k = 1:ni
    set(eval(['handles.ti', int2str(k)]),'String',int2str(tii(k)));
    set(eval(['handles.de', int2str(k)]),'String',int2str(dei(k)));
    set(eval(['handles.Pspeed', int2str(k)]), 'String', int2str(vpi(k)));
    set(eval(['handles.Sspeed', int2str(k)]), 'String', int2str(vsi(k)));
end

%set(handles.antlag,'String',n);
%handles.antlag = ni;

for k = 1:ni
    eval(['handles.ti', int2str(k), '=', int2str(tii(k)),';']) ;
    eval(['handles.de', int2str(k), '=', int2str(dei(k)),';']);
    eval(['handles.Pspeed', int2str(k), '=', int2str(vpi(k)),';']);
    eval(['handles.Sspeed', int2str(k), '=', int2str(vsi(k)),';']);
end

for k = ni+1:5
    eval(['handles.ti', int2str(k), '=0;']) ;
    eval(['handles.de', int2str(k), '=0;']);
    eval(['handles.Pspeed', int2str(k), '=0;']);
    eval(['handles.Sspeed', int2str(k), '=0;']);
end



    

% Choose default command line output for modell
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes modell wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = modell_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function edit18_Callback(hObject, eventdata, handles)
% hObject    handle to edit18 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit18 as text
%        str2double(get(hObject,'String')) returns contents of edit18 as a double


% --- Executes during object creation, after setting all properties.
function edit18_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit18 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit19_Callback(hObject, eventdata, handles)
% hObject    handle to edit19 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit19 as text
%        str2double(get(hObject,'String')) returns contents of edit19 as a double


% --- Executes during object creation, after setting all properties.
function edit19_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit19 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit20_Callback(hObject, eventdata, handles)
% hObject    handle to edit20 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit20 as text
%        str2double(get(hObject,'String')) returns contents of edit20 as a double


% --- Executes during object creation, after setting all properties.
function edit20_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit20 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit21_Callback(hObject, eventdata, handles)
% hObject    handle to edit21 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit21 as text
%        str2double(get(hObject,'String')) returns contents of edit21 as a double


% --- Executes during object creation, after setting all properties.
function edit21_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit21 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ti1_Callback(hObject, eventdata, handles)
% hObject    handle to ti1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ti1 as text
%        str2double(get(hObject,'String')) returns contents of ti1 as a double

ti1 = str2double(get(hObject, 'String'));
if isnan(ti1)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.ti1 = ti1;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function ti1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ti1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Pspeed1_Callback(hObject, eventdata, handles)
% hObject    handle to Pspeed1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Pspeed1 as text
%        str2double(get(hObject,'String')) returns contents of Pspeed1 as a double

Pspeed1 = str2double(get(hObject, 'String'));
if isnan(Pspeed1)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.Pspeed1 = Pspeed1;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function Pspeed1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Pspeed1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Sspeed1_Callback(hObject, eventdata, handles)
% hObject    handle to Sspeed1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Sspeed1 as text
%        str2double(get(hObject,'String')) returns contents of Sspeed1 as a double

Sspeed1 = str2double(get(hObject, 'String'));
if isnan(Sspeed1)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.Sspeed1 = Sspeed1;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function Sspeed1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Sspeed1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function de1_Callback(hObject, eventdata, handles)
% hObject    handle to de1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of de1 as text
%        str2double(get(hObject,'String')) returns contents of de1 as a double

de1 = str2double(get(hObject, 'String'));
if isnan(de1)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.de1 = de1;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function de1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to de1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ti2_Callback(hObject, eventdata, handles)
% hObject    handle to ti2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ti2 as text
%        str2double(get(hObject,'String')) returns contents of ti2 as a double

ti2 = str2double(get(hObject, 'String'));
if isnan(ti2)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.ti2 = ti2;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function ti2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ti2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Pspeed2_Callback(hObject, eventdata, handles)
% hObject    handle to Pspeed2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Pspeed2 as text
%        str2double(get(hObject,'String')) returns contents of Pspeed2 as a double

Pspeed2 = str2double(get(hObject, 'String'));
if isnan(Pspeed2)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.Pspeed2 = Pspeed2;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function Pspeed2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Pspeed2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Sspeed2_Callback(hObject, eventdata, handles)
% hObject    handle to Sspeed2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Sspeed2 as text
%        str2double(get(hObject,'String')) returns contents of Sspeed2 as a double

Sspeed2 = str2double(get(hObject, 'String'));
if isnan(Sspeed2)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.Sspeed2 = Sspeed2;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function Sspeed2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Sspeed2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function de2_Callback(hObject, eventdata, handles)
% hObject    handle to de2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of de2 as text
%        str2double(get(hObject,'String')) returns contents of de2 as a double

de2 = str2double(get(hObject, 'String'));
if isnan(de2)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.de2 = de2;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function de2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to de2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ti3_Callback(hObject, eventdata, handles)
% hObject    handle to ti3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ti3 as text
%        str2double(get(hObject,'String')) returns contents of ti3 as a double

ti3 = str2double(get(hObject, 'String'));
if isnan(ti3)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.ti3 = ti3;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function ti3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ti3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Pspeed3_Callback(hObject, eventdata, handles)
% hObject    handle to Pspeed3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Pspeed3 as text
%        str2double(get(hObject,'String')) returns contents of Pspeed3 as a double

Pspeed3 = str2double(get(hObject, 'String'));
if isnan(Pspeed3)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.Pspeed3 = Pspeed3;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function Pspeed3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Pspeed3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Sspeed3_Callback(hObject, eventdata, handles)
% hObject    handle to Sspeed3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Sspeed3 as text
%        str2double(get(hObject,'String')) returns contents of Sspeed3 as a double

Sspeed3 = str2double(get(hObject, 'String'));
if isnan(Sspeed3)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.Sspeed3 = Sspeed3;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function Sspeed3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Sspeed3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function de3_Callback(hObject, eventdata, handles)
% hObject    handle to de3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of de3 as text
%        str2double(get(hObject,'String')) returns contents of de3 as a double

de3 = str2double(get(hObject, 'String'));
if isnan(de3)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.de3 = de3;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function de3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to de3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit14_Callback(hObject, eventdata, handles)
% hObject    handle to edit14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit14 as text
%        str2double(get(hObject,'String')) returns contents of edit14 as a double


% --- Executes during object creation, after setting all properties.
function edit14_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit15_Callback(hObject, eventdata, handles)
% hObject    handle to edit15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit15 as text
%        str2double(get(hObject,'String')) returns contents of edit15 as a double


% --- Executes during object creation, after setting all properties.
function edit15_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit16_Callback(hObject, eventdata, handles)
% hObject    handle to edit16 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit16 as text
%        str2double(get(hObject,'String')) returns contents of edit16 as a double


% --- Executes during object creation, after setting all properties.
function edit16_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit16 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit17_Callback(hObject, eventdata, handles)
% hObject    handle to edit17 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit17 as text
%        str2double(get(hObject,'String')) returns contents of edit17 as a double


% --- Executes during object creation, after setting all properties.
function edit17_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit17 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ti4_Callback(hObject, eventdata, handles)
% hObject    handle to ti4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ti4 as text
%        str2double(get(hObject,'String')) returns contents of ti4 as a double

ti4 = str2double(get(hObject, 'String'));
if isnan(ti4)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.ti4 = ti4;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function ti4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ti4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Pspeed4_Callback(hObject, eventdata, handles)
% hObject    handle to Pspeed4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Pspeed4 as text
%        str2double(get(hObject,'String')) returns contents of Pspeed4 as a double

Pspeed4 = str2double(get(hObject, 'String'));
if isnan(Pspeed4)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.Pspeed4 = Pspeed4;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function Pspeed4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Pspeed4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Sspeed4_Callback(hObject, eventdata, handles)
% hObject    handle to Sspeed4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Sspeed4 as text
%        str2double(get(hObject,'String')) returns contents of Sspeed4 as a double

Sspeed4 = str2double(get(hObject, 'String'));
if isnan(Sspeed4)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.Sspeed4 = Sspeed4;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function Sspeed4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Sspeed4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function de4_Callback(hObject, eventdata, handles)
% hObject    handle to de4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of de4 as text
%        str2double(get(hObject,'String')) returns contents of de4 as a double

de4 = str2double(get(hObject, 'String'));
if isnan(de4)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.de4 = de4;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function de4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to de4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in antlag.
function antlag_Callback(hObject, eventdata, handles)
% hObject    handle to antlag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns antlag contents as cell array
%        contents{get(hObject,'Value')} returns selected item from antlag


% --- Executes during object creation, after setting all properties.
function antlag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to antlag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

set(hObject, 'String', {'1', '2', '3', '4', '5'});

% --- Executes on button press in fin.
function fin_Callback(hObject, eventdata, handles)
% hObject    handle to fin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

n = get(handles.antlag, 'Value');


for k = 1:n
    ti(k) = eval(['handles.ti', int2str(k)]);
    de(k) = eval(['handles.de', int2str(k)]);
    vp(k) = eval(['handles.Pspeed', int2str(k)]);
    vs(k) = eval(['handles.Sspeed', int2str(k)]);
end
guidata(hObject,handles)

save geomodel n ti de vp vs
delete(handles.figure1)



function ti5_Callback(hObject, eventdata, handles)
% hObject    handle to ti5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ti5 as text
%        str2double(get(hObject,'String')) returns contents of ti5 as a double

ti5 = str2double(get(hObject, 'String'));
if isnan(ti5)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.ti5 = ti5;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function ti5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ti5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Pspeed5_Callback(hObject, eventdata, handles)
% hObject    handle to Pspeed5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Pspeed5 as text
%        str2double(get(hObject,'String')) returns contents of Pspeed5 as a double

Pspeed5 = str2double(get(hObject, 'String'));
if isnan(Pspeed5)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.Pspeed5 = Pspeed5;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function Pspeed5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Pspeed5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Sspeed5_Callback(hObject, eventdata, handles)
% hObject    handle to Sspeed5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Sspeed5 as text
%        str2double(get(hObject,'String')) returns contents of Sspeed5 as a double

Sspeed5 = str2double(get(hObject, 'String'));
if isnan(Sspeed5)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.Sspeed5 = Sspeed5;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function Sspeed5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Sspeed5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function de5_Callback(hObject, eventdata, handles)
% hObject    handle to de5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of de5 as text
%        str2double(get(hObject,'String')) returns contents of de5 as a double

de5 = str2double(get(hObject, 'String'));
if isnan(de5)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new volume value
handles.de5 = de5;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function de5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to de5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


