function o_write(Phen, premodel, nlayers, nParm, inv_parameters)
% Overwrite the information in already created pre files.

[Nind, Nvar] = size(Phen);


for j = 1:Nind

%Start writing to file:

fid = fopen(['model_' num2str(j,'%3.2d') '.pre'],'r+');
%delete(['model_' num2str(j,'%3.2d') '.out']);

Geo_subsection = premodel;

water_d = premodel(2,2);
for k = 1:nParm
    idx = (k-1)*nlayers+1:k*nlayers;
    switch (inv_parameters(k,:))
        case ('ti')
                tickness = water_d + cumsum(Phen(j, idx(1:end-1)))';
                Geo_subsection(3:end-1,2) = tickness;
                Geo_subsection(end,2) = premodel(end, 2);       
        case ('Vp')
            Geo_subsection(3:end,3) = Phen(j,idx)';
        case ('Vs')
            Geo_subsection(3:end,4) = Phen(j,idx)';
        case ('ap')
            Geo_subsection(3:end,5) = Phen(j,idx)';
        case ('as')
            Geo_subsection(3:end,6) = Phen(j,idx)';
        case ('de')
            Geo_subsection(3:end,7) = Phen(j,idx)';
        case ('Vw')
            Geo_subsection(2,3) = Phen(j,end);
    end
end

% fseek(fid, 337, -1);
fseek(fid, 393, -1);
% fseek(fid, 0, -1);
fprintf(fid, '%7d %8d %8d %8d %9.3f %9.1f %9d \n', Geo_subsection(1,:));
fprintf(fid, '%7d %8.2d %8d %8d %9.3f %9.1f %9d \n', Geo_subsection(2,:));
fprintf(fid, '%7d %8.2f %8.2f %8.2f %9.2f %9.2f %9.2d \n', Geo_subsection(3,:));
fprintf(fid, '%7d %8.2f %8.2f %8.2f %9.2f %9.2f %9.2d \n', Geo_subsection(4,:));
fprintf(fid, '%7d %8.1g %8.2f %8.2f %9.2f %9.2f %9.2d \n', Geo_subsection(5,:));


end
fclose('all');
    