function trans_loss = plane_ray_all(wdepth, ldepth, RUNP1, c0, rho0, cp1, cp2, cs1, cs2, rho1, rho2)

%% Plane Ray 1

if RUNP1 == 1
% clear
% clear global
clear EIG_THETA EIG_RANGE; 
global c z del_z depth angle
global BOTTOM_RANGE BOTTOM_ANGLE BOTTOM_COUNT SURFACE_RANGE  SURFACE_COUNT TURNING_ABOVE_COUNT TURNING_BELOW_COUNT EIG_RANGE EIG_ANGLE;
   
global  theta_0 z c start_theta lay_thick_int depth

teller =1;

plane_input;

z_max=max(z_input); 
[depth angle]=bottom_int(R_b,Z_b);
c=c_input;
z=z_input;
del_z=del_z_input;
c_max=5*fix(max(c)/5)+10;
c_min=5*fix(min(c)/5)-5;
z_bottom=max(z);
del_z=del_z_input/interpol_factor;
z_interpolated=0:del_z:max(z);
c_interpolated=interp1(z,c,z_interpolated,'spline');
K=length(c_interpolated);
c_interpolated=[c_interpolated c_interpolated(K)] ;
z_interpolated=[z_interpolated z_interpolated(K)+del_z];

number_of_rays=length(start_theta);
eig_theta=0; eig_p=0; eig_range=0; eig_time=0;
start_theta=sort(start_theta);
%tic;
for ray_number=1:number_of_rays;
    
   
    theta_deg=start_theta(ray_number)+eps;
    if theta_deg>=0; dir=1; end; if theta_deg<0; dir=-1; end;
    theta_current=theta_deg*pi/180; theta_0(ray_number)=theta_current;
    

       
    if linear==1;
        [ X, Z, TT,eig_angle, eig_range,eig_time,eig_theta,....
                bottom_label,surface_label,turning_above_label,turning_below_label,bottom_angle, bottom_range,surface_range]....
            =trace_ray_lin(beamdisplacement,theta_deg, range_source,z_source, z_receiver,  N, R_stop, T_max);
         
    end;
   
    if linear==0
        [ X, Z, TT,eig_angle, eig_range,eig_time,eig_theta,....
                bottom_label,surface_label,turning_above_label,turning_below_label,bottom_angle, bottom_range,surface_range]....
            =trace_ray_circ(beamdisplacement,theta_deg, range_source,z_source, z_receiver,  N, R_stop, T_max);
    
    end;
    %time=toc;
    
%     if teller ==10
%      disp([ 'Angle =' num2str(start_theta(ray_number))  ' deg' '  Time ' num2str(time) ' s'])
%      teller=1;
%     end
    teller = teller +1;
    X=X(Z>0); Z=Z(Z>0);

    EIG_TIME(ray_number,1:length(eig_time))=eig_time;
    EIG_RANGE(ray_number,1:length(eig_range))=eig_range;
    EIG_THETA(ray_number,1:length(eig_theta))=eig_theta;
    EIG_ANGLE(ray_number,1:length(eig_angle))=eig_angle;
    BOTTOM_COUNT(ray_number,1:length(bottom_label))=bottom_label;
    SURFACE_COUNT(ray_number,1:length(surface_label))=surface_label;
    TURNING_ABOVE_COUNT(ray_number,1:length(turning_above_label))=turning_above_label;
    TURNING_BELOW_COUNT(ray_number,1:length(turning_below_label))=turning_below_label;
    BOTTOM_ANGLE(ray_number,1:length(bottom_angle))=bottom_angle;
    BOTTOM_RANGE(ray_number,1:length(bottom_range))=bottom_range;
    SURFACE_RANGE(ray_number,1:length(surface_range))=surface_range;
      
    N_bottom_range=length(bottom_range);
end;


[Na,Ni]=size(BOTTOM_RANGE);
for na=1:1:Na;
    for ni=1:1:Ni;
        W=BOTTOM_RANGE(na,ni);
        if W<=1; BOTTOM_RANGE(na,ni)=R_max;
        end;
    end;    
end;

[Na,Ni]=size(SURFACE_RANGE);
for na=1:1:Na;
    for ni=1:1:Ni;
        W=SURFACE_RANGE(na,ni);
        if W<=1; SURFACE_RANGE(na,ni)=R_max;
        end;
    end;    
end;



if store==1
    store;
    save BOTTOM_COUNT BOTTOM_COUNT;
    save SURFACE_COUNT SURFACE_COUNT;
    save TURNING_ABOVE_COUNT TURNING_ABOVE_COUNT;
    save TURNING_BELOW_COUNT TURNING_BELOW_COUNT;
    save EIG_ANGLE EIG_ANGLE;
    save EIG_RANGE EIG_RANGE;
    save EIG_TIME EIG_TIME;
    save EIG_THETA EIG_THETA;
    save BOTTOM_ANGLE BOTTOM_ANGLE 
    save BOTTOM_RANGE BOTTOM_RANGE 
    save SURFACE_RANGE SURFACE_RANGE 
    save theta_0 theta_0;
    save z z;
    save c c;
    save start_theta start_theta;
    save lay_thick_int lay_thick_int ;
    save angle angle
    save depth depth
   
end;
end;

%% Plane Ray 2

%tic;
plane_input;
first_phone_position=100; phone_spacing=500; %N_phones=95;
R_max=3000; % N_step=4;

%for jj=1:N_phones; phone_positions(jj)=first_phone_position+phone_spacing*jj;end;

phone_positions = first_phone_position:phone_spacing:R_max;
N_phones = length(phone_positions);

%c_red=c0;

%load BOTTOM_COUNT; bottom_count=BOTTOM_COUNT;
%load SURFACE_COUNT;surface_count=SURFACE_COUNT;
load TURNING_BELOW_COUNT;
load TURNING_ABOVE_COUNT;
load EIG_RANGE;
load EIG_TIME;
load EIG_THETA;
load EIG_ANGLE;
load BOTTOM_ANGLE ;
load angle
%bottom_angle=BOTTOM_ANGLE*180/pi;%Convert to degree
load BOTTOM_RANGE ; %bottom_range=BOTTOM_RANGE;
load SURFACE_RANGE; %surface_range=SURFACE_RANGE;
load start_theta;
start_angle=start_theta;
load z;
load c;
load depth;

% eig_range=EIG_RANGE;
% eig_theta=EIG_THETA;
% eig_time=EIG_TIME;
% eig_angle=EIG_ANGLE;

% bottom_count=BOTTOM_COUNT;
% surface_count=SURFACE_COUNT;
% bottom_count=BOTTOM_COUNT;
% turning_above_count=TURNING_ABOVE_COUNT;
% turning_below_count=TURNING_BELOW_COUNT;
% 
% eig_theta=eig_theta*180/pi;%Convert to degrees
% eig_angle=eig_angle*180/pi;%Convert to degrees
% c_red=max(c_input);
% eig_time_true=eig_time;
% eig_time_red=eig_time-eig_range/c_red; % Reduced travel time in secs

%[K1 K2]=size(eig_theta);
K2=1; %I just choose this to be the same in all
filterlength=1; %Also just choosen

clear range_int
range_int=1:1:R_max;
%Nr = length(range_int);

%R1_int=range_int;   R2_int=range_int;
%R3_int=range_int;   R4_int=range_int;   R0_int=range_int;
Nr = length(range_int);
c_target=c0;
%method='linear';

%last_1=1000; last_2=1000; last_3=1000;

for Klass=1:11;
%tid = toc;
   % disp([ 'Klasse = ' num2str(Klass) ' tid ' num2str(tid) 'sek'])
    for ii=1:K2;
        iii=ii;
        
        switch Klass
            case 1
                [T_temp R_temp A_temp TA_temp] =select_arrival(0,0,0,0,0);
            case 2
                [T_temp R_temp A_temp TA_temp] =select_arrival(ii-1,ii,0,0,0);
            case 3
                [T_temp R_temp A_temp TA_temp] =select_arrival(ii,ii,0,0,1);
            case 4
                [T_temp R_temp A_temp TA_temp] =select_arrival(ii,ii,0,0,-1);
            case 5
                [T_temp R_temp A_temp TA_temp] =select_arrival(ii,ii-1,0,0,0);
            case 6
                [T_temp R_temp A_temp TA_temp] =select_arrival(iii-1,0,iii,0,0);
            case 7
                [T_temp R_temp A_temp TA_temp] =select_arrival(iii,0,iii,0,1);
            case 8
                [T_temp R_temp A_temp TA_temp] =select_arrival(iii,0,iii,0,-1);
            case 9
                [T_temp R_temp A_temp TA_temp] =select_arrival(0,iii-1,0,iii,0);
            case 10
                [T_temp R_temp A_temp TA_temp] =select_arrival(0,iii,0,iii,1);
            case 11
                [T_temp R_temp A_temp TA_temp] =select_arrival(0,iii,0,iii-1,-1);
        end


        T_temp=T_temp(R_temp>0); A_temp=A_temp(R_temp>0);
        TA_temp=TA_temp(R_temp>0); R_temp=R_temp(R_temp>0);
        Ni=length(T_temp);
        if Ni>0;
            T(Klass,ii,1:Ni)=T_temp';
            R(Klass,1:Ni)=R_temp'; A(Klass,1:Ni)=A_temp'; TA(Klass,1:Ni)=TA_temp';

            T(Klass,ii,1:Ni)=T_temp';
            R(Klass,1:Ni)=R_temp';
            A(Klass,1:Ni)=A_temp';
            TA(Klass,1:Ni)=TA_temp';


            if length(T_temp)>2;
                [amp_int,TL_int,A_int TA_int,T_int]=new(filterlength,range_int,R_temp,A_temp,TA_temp,T_temp ,c0, c_target);
                rayamp(Klass,ii,1:Nr)=amp_int;
                transloss(Klass,ii,1:Nr)=TL_int;
                startangle(Klass,ii,1:Nr)=A_int;
                targetangle(Klass,ii,1:Nr)=TA_int;
                delay(Klass,ii,1:Nr)=T_int;
            else
                delay(Klass,ii,1:length(T_temp))=T_temp;
                delay(Klass,ii,length(T_temp)+1:Nr)=0.0;
                startangle(Klass,ii,1:length(T_temp))=A_temp';
                startangle(Klass,ii, length(T_temp)+1:Nr)=0.0;
                targetangle(Klass,ii, length(T_temp)+1:Nr)=0.0;
                transloss(Klass,ii,1:Nr)=200.0;
                rayamp(Klass,1,1:Nr)=0;
            end

        end;

    end %iii  & ii
end %Klass


%D=depth;
eigenangle_turn_above = zeros(N_phones,12);
eigenangle_turn_below = zeros(N_phones,12);
eigenangle = zeros(N_phones,4*K2);
%eigenangle_direct=zeros(N_phones,1);

for jj=1:N_phones;

    receiver_range=phone_positions(jj);
%     RA_0(jj,:)=rayamp(1,:,receiver_range);
%     RA_1(jj,:)=rayamp(2,:,receiver_range);
%     RA_2(jj,:)=rayamp(3,:,receiver_range);
%     RA_3(jj,:)=rayamp(4,:,receiver_range);
%     RA_4(jj,:)=rayamp(5,:,receiver_range);
%     RA_5(jj,:)=rayamp(6,:,receiver_range);
%     RA_6(jj,:)=rayamp(7,:,receiver_range);
%     RA_7(jj,:)=rayamp(8,:,receiver_range);
%     RA_8(jj,:)=rayamp(9,:,receiver_range);
%     RA_9(jj,:)=rayamp(10,:,receiver_range);
%     RA_10(jj,:)=rayamp(11,:,receiver_range);

    TL_0(jj,:)=transloss(1,:,receiver_range);
    TL_1(jj,:)=transloss(2,:,receiver_range);
    TL_2(jj,:)=transloss(3,:,receiver_range);
    TL_3(jj,:)=transloss(4,:,receiver_range);
    TL_4(jj,:)=transloss(5,:,receiver_range);
    TL_5(jj,:)=transloss(6,:,receiver_range);
    TL_6(jj,:)=transloss(7,:,receiver_range);
    TL_7(jj,:)=transloss(8,:,receiver_range);
    TL_8(jj,:)=transloss(9,:,receiver_range);
    TL_9(jj,:)=transloss(10,:,receiver_range);
    TL_10(jj,:)=transloss(11,:,receiver_range);


    DL_0(jj,:)=delay(1,:,receiver_range);
    DL_1(jj,:)=delay(2,:,receiver_range);
    DL_2(jj,:)=delay(3,:,receiver_range);
    DL_3(jj,:)=delay(4,:,receiver_range);
    DL_4(jj,:)=delay(5,:,receiver_range);
    DL_5(jj,:)=delay(6,:,receiver_range);
    DL_6(jj,:)=delay(7,:,receiver_range);
    DL_7(jj,:)=delay(8,:,receiver_range);
    DL_8(jj,:)=delay(9,:,receiver_range);
    DL_9(jj,:)=delay(10,:,receiver_range);
    DL_10(jj,:)=delay(11,:,receiver_range);

    %select_angle_0=startangle(1,:,receiver_range);
    select_angle_1=startangle(2,:,receiver_range);
    select_angle_2=startangle(3,:,receiver_range);
    select_angle_3=startangle(4,:,receiver_range);
    select_angle_4=startangle(5,:,receiver_range);
    %select_angle_5=startangle(6,:,receiver_range);
    select_angle_6=startangle(7,:,receiver_range);
    select_angle_7=startangle(8,:,receiver_range);
    select_angle_8=startangle(9,:,receiver_range);
    select_angle_9=startangle(10,:,receiver_range);
    select_angle_10=startangle(11,:,receiver_range);


    temp1=[TL_1(jj,:) TL_2(jj,:) TL_3(jj,:) TL_4(jj,:) ]';
    TL(jj,1:length(temp1))=temp1';
    %temp2=[RA_1(jj,:) RA_2(jj,:) RA_3(jj,:) RA_4(jj,:) ]';
    %RA(jj,1:length(temp2))=temp2';

    temp=[DL_1(jj,:) DL_2(jj,:) DL_3(jj,:) DL_4(jj,:) ]';
    DL(jj,1:length(temp))=temp';
    select_ang=[select_angle_1' select_angle_2' select_angle_3' select_angle_4'  ];

    select_ang=select_ang(select_ang>0|select_ang<0);
    eigenangle(jj,1:length(select_ang))=select_ang';
    temp_turn1=[TL_5(jj,:) TL_6(jj,:) TL_7(jj,:)]';
    TL_turn_above(jj,1:length(temp_turn1))=temp_turn1';
    %temp_turn2=[RA_5(jj,:) RA_6(jj,:) RA_7(jj,:)]';
    %RA_turn_above(jj,1:length(temp_turn2))=temp_turn2';

    temp_turn_above=[DL_5(jj,:)  DL_6(jj,:) DL_7(jj,:)  ]';
    DL_turn_above(jj,1:length(temp_turn_above))=temp_turn_above';

    select_ang_turn_above=[ select_angle_6  select_angle_7 select_angle_8];
    select_ang_turn_above=select_ang_turn_above(select_ang_turn_above>0|select_ang_turn_above<0);
    eigenangle_turn_above(jj,1:length(select_ang_turn_above))=select_ang_turn_above;


    temp_turn_below1=[TL_8(jj,:) TL_9(jj,:) TL_10(jj,:) ]';
    TL_turn_below(jj,1:length(temp_turn_below1))=temp_turn_below1';
    %temp_turn_below2=[RA_8(jj,:) RA_9(jj,:) RA_10(jj,:) ]';
    %RA_turn_below(jj,1:length(temp_turn_below2))=temp_turn_below2';

    temp_turn_below=[DL_8(jj,:)  DL_9(jj,:) DL_10(jj,:)  ]';
    DL_turn_below(jj,1:length(temp_turn_below))=temp_turn_below';

    select_ang_turn_below=[  select_angle_8' select_angle_9'  select_angle_10' ];
    select_ang_turn_below=select_ang_turn_below(select_ang_turn_below>0|select_ang_turn_below<0);
    eigenangle_turn_below(jj,1:length(select_ang_turn_below))=select_ang_turn_below';
    %eigen_angle_turn=[eigenangle_turn_above eigenangle_turn_below];
end; %over jj
%% Plane ray 3

%Using a Ricker source type:
    NN=2048; fs=512; %f_max=100;
    %N=NN;
    q=1:NN/2; %n=1:NN; 
    %source_signal=zeros(1,NN);
    %delta_t=1/fs; t=n*delta_t; t_max=max(t);
    f=(q-1)*fs/NN; omega=2*pi*f; %delta_f=fs/NN; 

    %T_D=sqrt(6)/(pi*f_max);% Time separation between the two negative peaks
    %t_0=7*T_D;
    %source=Ricker(f_max,t_0,fs,NN);
    %source_signal=source;
    %W=fft(source_signal,NN);
    %source_spectrum=W(1:NN/2);
    
        %f_max= 200;
    %T_D=sqrt(6)/(pi*f_max);% Time separation between the two negative peaks
    %t_0=5*T_D;
    %source=ricker(f_max,t_0,fs,NN);
    %source_signal=source;
    %W=fft(source_signal,NN);
    %source_spectrum=W(1:NN/2)+eps;
    

        %title_tekst=['Pekeris 50 meter']
    sigma_surface_wave=.0; %Sea surface roughness
    c_red=1500;
    dblambdap0=0;   %c0=c0;    rho0=1000;   
     dblambdap1=0.5;
    %cp1=1800 ;  cs1=0;  rho1=2000; dblambdap1=0.5;
     dblambdap2=0.5;   dblambdas2=0.5; %rock
    %cp2=1800;  cs2=.0001; rho2=1800;  dblambdap2=0.5;   dblambdas2=0;
    %cp2=5300;  cs2=2000; rho2=2500;  dblambdap2=0.5;   dblambdas2=0.5;    %salt
    lay_thick=ones(1,length(R_b))*ldepth;


    %konst=8.686*2*pi;
    %dB_lambda=0.50;
    %alpha=dB_lambda/konst;

    %ccp1=[ 1800 1800 1800]*(1+i*alpha);
    %ccp2=[ 2400 5300 2400]*(1+i*alpha);
    %ccs2=[ 200 2000 200]*(1+i*alpha);
    %rrho1=[ 1800 1800 1800];
    %rrho1=[ 1800 2000 1800];
    %rrho2=[ 2000 2500 2000];
    %rrho2=[ 2000 2000 2000];
    %RR=[25000 35000 50000];
    %RR=[50000 50000 50000];
    %DD=[5 5 5];
    
    konst=8.686*2*pi;
dp0=dblambdap0/konst; dp1=dblambdap1/konst; dp2=dblambdap2/konst; ds2=dblambdas2/konst;
c0=c0*(1+i*dp0); cp1=cp1*(1+i*dp1); cp2=cp2*(1+i*dp2); cs2=cs2*(1+i*ds2);

II_max=4*K2;
%I=II_max;
%K=K2;
%k=1:K;
% Angle contains K2*4 eigenangles for the the current range
lambda=1500./(f+eps);

clear signal signal_0 signal_turn tot_signal_spectrum  trans_loss;
clear bias t_red t_real;
%tic
for jj=1:N_phones;


    
    receiver_range=phone_positions(jj);
    % phone_distance(jj)=receiver_range;
    % R_max=max(receiver_range);
    % Setting up the arrays for the frequency responses
    transfer_function=zeros(1,NN/2);
    %transfer_function_0=zeros(1,NN/2);
    transfer_function_turn=zeros(1,NN/2);
    %frequency_function=zeros(1,NN/2);
    tot_transfer_function=zeros(1,NN/2);

    %phone_distance(jj)=receiver_range;

    %angle_temp=eigenangle(jj,:);% degree
    %angle_temp_turn_above=eigenangle_turn_above(jj,:);%degre
   % angle_temp_turn_below=eigenangle_turn_below(jj,:);%degre

    % Syntesize the ordinary arrivals
    for ii=1:II_max;
       % N_surface=0;N_bottom=0;
        current_angle=eigenangle(jj,ii);
        R_s=surface_reflection(lambda, sigma_surface_wave,  current_angle*pi/180);
        %TLoss =TL(jj,ii);
        if current_angle~=0;
            delay=DL(jj,ii)-receiver_range/c_red;
           % DL_red(jj,ii)=delay;
            temp_a= interp1(start_angle,BOTTOM_ANGLE,current_angle,'linear');
            temp_r= interp1(start_angle,BOTTOM_RANGE,current_angle,'linear');
            temp_s= interp1(start_angle,SURFACE_RANGE,current_angle,'linear');
            range_bottom=temp_r(temp_r>0 & temp_r<receiver_range);
            range_surface=temp_s(temp_s>0 & temp_s<receiver_range);
            theta_bottom=temp_a(temp_r>0 & temp_r<receiver_range);
            N_bottom=length(range_bottom);P=N_bottom;
            N_surface=length(range_surface);
            bottom_ref=1;
            w=TL(jj,ii); amp=10^(-w/20);
            E=exp(-i*omega*delay);
            surface_ref=R_s*(-1)^N_surface; s1=surface_ref;
            surface_ref=sign(ii)*R_s; s2=surface_ref;
            surface_ref=R_s*(-1)^N_surface;
            if s1~=s2; diagnostic(jj,:)=[ receiver_range/1000 current_angle s1 s2 N_surface N_bottom ]; end
            %diagnostic(jj,:)=[ receiver_range/1000 current_angle s1 s2 N_surface N_bottom ];
            for pp=1:P;
                bottom_range=fix(range_bottom(pp));
                if bottom_range>1;
                    bottom_depth=fix(depth(bottom_range));
                    c_depth=c(fix(bottom_depth/del_z));
                    theta=theta_bottom(pp);
%                     if bottom_range<=RR(1); cp1=ccp1(1); cp2=ccp2(1); cs2=ccs2(1);  rho1=rrho1(1); rho2=rrho2(1); d=DD(1); end;
%                     if bottom_range>RR(1)& bottom_range<=RR(2); cp1=ccp1(2); cp2=ccp2(2); cs2=ccs2(2);  rho1=rrho1(2); rho2=rrho2(2); d=DD(2); end;
%                     if bottom_range>RR(2); cp1=ccp1(3); cp2=ccp2(3); cs2=ccs2(3);  rho1=rrho1(3); rho2=rrho2(3); d=DD(3); end;
                    %disp( [ bottom_range cp2 cs2 rho2]);
                    d=interp1(R_b,lay_thick,bottom_range);
                    R=R_thin_layer(theta,f,c_depth,cp1,cp2,cs2,rho1,rho2,d);
                    bottom_ref=bottom_ref.*R;
                end
            end
        end;
        transfer_function=transfer_function+E.*amp.*bottom_ref.*surface_ref;
        % TTT(ii) =-20*log10(max(abs(transfer_function)));

    end;%ii


    %The direct signal
    R=sqrt(receiver_range^2+(z_source-z_receiver)^2);
    TL_0(jj,1)=20*log10(R);
    DL_0(jj,1)=R/c0;
    %

    w=TL_0(jj,1);
    delay=DL_0(jj,1)-receiver_range/c_red;
    %delay=DL_0(jj)-receiver_range/c_red;
    amp=10^(-w/20);
    E=exp(-i*omega*delay);
    transfer_function_0=E*amp;

    %Calculate the refracted arrivals-above;
    %III=size(eigenangle_turn_above( 1,:));
    %III_max=III(2);
    III_max=0;
    for ii=1:III_max
        R_turn=(-i)^ii;
        current_angle=eigenangle_turn_above(jj,ii);
        clear temp_r_turn temp_a_turn range_bottom_turn theta_bottom_turn;
        %  if TLoss>0& current_angle~=0;
        if current_angle~=0;
            delay=DL_turn_above(jj,ii)-receiver_range/c_red;
            temp_r_turn= interp1(start_angle,BOTTOM_RANGE,current_angle,'linear');
            temp_a_turn= interp1(start_angle,BOTTOM_ANGLE,current_angle,'linear');
            range_bottom_turn=temp_r_turn(temp_r_turn>0 & temp_r_turn<receiver_range);
            theta_bottom_turn=temp_a_turn(temp_r_turn>0 & temp_r_turn<receiver_range);
            bottom_ref=1;
            w=TL_turn_above(jj,ii);amp=10^(-w/20);
            if w>0&w>1000;
                E=exp(-i*omega*delay);
                P=length(range_bottom_turn);

                for pp=1:P;
                    %range=range_bottom_turn(pp);
                    theta=theta_bottom_turn(pp);
                    bottom_ref=bottom_ref.*R_thin_layer(theta,f,c0,cp1,cp2,cs2,rho1,rho2,d);
                end
                transfer_function_turn=transfer_function_turn+E*amp.*bottom_ref*R_turn;
            end;
        end;
    end;%ii
    tot_transfer_function(jj,:)=transfer_function+transfer_function_0 +transfer_function_turn;


    %Refracted_below contributions
    %III=size(eigenangle_turn_below( 1,:));

    %III_max=III(2);
    III_max=0;
    for ii=1:III_max
        R_turn=(i)^ii;
        current_angle=eigenangle_turn_below(jj,ii);
        clear temp_r_turn temp_a_turn range_bottom_turn theta_bottom_turn;
        delay_temp=DL_turn_below(jj,ii);
        if current_angle~=0 & delay_temp ~=1000;
            delay=delay_temp-receiver_range/c_red;
            temp_r_turn= interp1(start_angle,BOTTOM_RANGE,current_angle,'linear');
            temp_a_turn= interp1(start_angle,BOTTOM_ANGLE,current_angle,'linear');
            range_bottom_turn=temp_r_turn(temp_r_turn>0 & temp_r_turn<receiver_range);
            theta_bottom_turn=temp_a_turn(temp_r_turn>0 & temp_r_turn<receiver_range);
            bottom_ref=1;
            w=TL_turn_below(jj,ii); amp=10^(-w/20);
            if w>0&w>1000;
                E=exp(-i*omega*delay);
                P=length(range_bottom_turn);
                for pp=1:P;
                    %range=range_bottom_turn(pp);
                    theta=theta_bottom_turn(pp);
                    bottom_ref=bottom_ref.*R_thin_layer(theta,f,c0,cp1,cp2,cs2,rho1,rho2,d);
                end
                transfer_function_turn=transfer_function_turn+E*amp.*bottom_ref*R_turn;
            end;
        end;
    end;%ii
    tot_transfer_function(jj,:)=transfer_function+transfer_function_0 +transfer_function_turn;


    % Convert to time domain
%     signal_spectrum=source_spectrum.*transfer_function;
%     signal_spectrum_0=source_spectrum.*transfer_function_0;
%     signal_spectrum_turn=source_spectrum.*transfer_function_turn;
%     tot_signal_spectrum(jj,:)=signal_spectrum+signal_spectrum_0+signal_spectrum_turn;
    trans_loss(jj,:)=-20*log10(eps+abs(tot_transfer_function(jj,:)));

%     scale_time=5000;
%     signal(jj,:)=2*scale_time*real(ifft(signal_spectrum,NN)); % Ordinary arrivals
%     signal_0(jj,:)=2*scale_time*real(ifft(signal_spectrum_0,NN)); % Direct arrival
%     signal_turn(jj,:)=2*scale_time*real(ifft(signal_spectrum_turn,NN)); % Refracted arrivals
%     bias(jj,1:length(t))=phone_positions(jj);
%     t_red(jj,:)=t;
%     t_real(jj,:)=t+receiver_range/c_red;
    %time=toc;
   % disp( ['Receiver range = ' num2str( receiver_range)  '   Time = ' num2str(time) ' s'  ])
end;