% Plot a completed inversion again.

scrsz = get(0,'ScreenSize');

set(figure(10),'Position',[1 -50 scrsz(3) round(scrsz(4)/1.1)]);
k=0;
for j = 1:nParm
    for l = 1:nlayers
        k = k + 1;
        switch (inv_parameters(j,:))
            case ('Vp')
                label{k} = ['P-vel. ', num2str(l)];
                %obs(k) = model_matrix(2+l,3);
                obs(k) = model_matrix(1+l,3);
            case ('Vs')
                label{k} = ['S-vel. ', num2str(l)];
                %obs(k) = model_matrix(2+l,4);
                obs(k) = model_matrix(1+l,4);
            case ('ap')
                label{k} = ['P-att. ', num2str(l),];
                obs(k) = model_matrix(2+l,5);
            case ('as')
                label{k} = ['S-att. ', num2str(l)];
                obs(k) = model_matrix(2+l,6);
            case ('de')
                label{k} = ['Density ', num2str(l)];
                %obs(k) = model_matrix(2+l,7);
                obs(k) = model_matrix(1+l,2);
            case ('ti')
                label{k} = ['Layer thickness ', num2str(l)];
                %obs(k) = model_matrix((2+l),2)- model_matrix((1+l),2);
                if l<(nlayers-1)
                    obs(k) = model_matrix((2+l),1)- model_matrix((1+l),1);
                else
                    obs(k) =obs(k-1);
                end
        end
    end
end
obs=obs.*1000;
ymin = min(min_phen)*0.99;
ymax = max(min_phen)*1.01;
V = nPar; H = 2;
height = 1:2:2*nPar;

if length(obs) < nPar
    obs(end+1:nPar)=0;
end

for j = 1:gen
    figure(10);
    for i=2:2:2*nPar
        subplot(V,H,i);
        hold on; plot(min_phen(1:j,i/2));
        plot(obs(i/2)*ones(1,gen), ':k');
        hold off;
        %text(0.5,0.8,['Current value = ', num2str(min_phen(j,i/2))], 'Units','normalized');
        xlim([0 ceil(gen*1.2)]);
        ylim([ymin(i/2) ymax(i/2)])
    end
    drawnow;
    
    
    pause(0.01);
    subplot(V,H,height); plot(min_gen(1:j),'--w.','LineWidth',2,'MarkerEdgeColor','r','MarkerFaceColor','g','MarkerSize',10);
    hold on; plot(avg(1:j),':w.','LineWidth',2,'MarkerEdgeColor','b','MarkerFaceColor','b','MarkerSize',10); hold off;
    axis([0 Options.maxgen 0 inf]);
    title(['Best = ', num2str(min_gen(j)),'   Mean = ',num2str(avg(j))],'Units','normalized');
    xlabel('Generation'); 
    %ylabel('f(x)');
    drawnow;
    pause(0.1);
end
    