function[amp,TLdB]=ray_loss (filterlength,range,theta_0, theta_target,c0,c_target);
% Computes the the transmission loss in dB (TLdB) and the ray amplitude (amp)
% for distances given by range, initial angle (theta_0), angle at receiver
%(theta_target).
% c0 and c_target are the sound speed at the source and the receiver
% depths respectively

% range in meter
% angles in radians
%c0 = sound speed at source depth
%c_target = sound speed at receiver depth
%theta_0 = initial angle in radians
%theta_target = angle at the target in radians
% filterlength=length of smoothing filter;
X=1/filterlength*ones(1,filterlength);
R=range;
N=length(theta_0);
A=theta_0; 
TA=theta_target; 
maks=1./(range.*range);I_max=maks(1:N-1);
w1=diff(A)./diff(R);
w2=A(1:N-1);
w3=R(1:N-1);
w4=TA(1:N-1);
I=(1./w3).*(cos(w2)./(sin(w4)+eps)).*w1; 
I_int=filter(X,[1],I); I=I_int;
I=abs(I);
amp=sqrt(I);amp(amp>1)=eps;
TLdB=-10 *log10(abs(I)+10^(-20));
TLdB(TLdB<0)=200;







