%trace_ray_lin



function [R, Z, T,eig_angle, eig_range,eig_time,eig_theta,bottom_label,surface_label,......
        turning_above_label,turning_below_label,bottom_angle,bottom_range,surface_range].....
    = trace_ray_lin_new(beamdisp,theta_deg, range_source,z_source, z_receiver,  N, R_max, T_max);
global c z del_z   depth angle
% Set up start values
surface_label=0; bottom_label=0; turning_above_label=0; turning_below_label=0;
eig_p=0; eig_theta=0; eig_time=0; eig_range=0; eig_angle=0;
target_count=0; bottom_stop=0; delta_t=0; delta_x=0; delta_z=0;
t_temp=0; bottom_hits=0; turning_above=0; turning_below=0; 
surface_hits=0; surface_range=0; bottom_range=0;bottom_angle=0;
%below_range=0; above_range=0; 
R=0; Z=0;
del_z=z(2)-z(1);
K=length(c);
k_target=round(z_receiver/del_z)+1; k_start=round(z_source/del_z)+1;

% Initial settings for the ray starting with theta_deg
theta_0=theta_deg*pi/180; theta_current=theta_0; start_angle=theta_deg;
dir=sign(theta_deg); p_current=cos(theta_0)./c(z==z_source);
x_temp=range_source; k=k_start; z_temp=z_source;target_count=0;
R=zeros(1,N);T=zeros(1,N);Z=zeros(1,N);
for n=1: N %Counter along the ray
    if x_temp>=R_max| abs(theta_current)>=pi/2;  break; ;   end;
    m=round(x_temp+1);
    if m>=length(depth);m=length(depth);end;
    depth_current=depth(m);
    angle_current=angle(m);
    
    if dir==1; % ---------Down going wave------------------------------ 
        if z_temp>=depth_current; %Bottom detected
            if bottom_stop==1 ; break; end;
            
            bottom_hits=bottom_hits+1; dir=-1; %Increment number of bottom hits and turn
            delta_x=0; delta_z=0;  delta_t=0; 
            k_bottom=fix(depth_current/del_z); c_bottom=c(k_bottom);
            theta_current=acos(p_current*c_bottom)+2*angle_current;
            p_current=cos(theta_current)/c_bottom; 
            bottom_range(bottom_hits)=x_temp;
            bottom_angle(bottom_hits)=theta_current-angle_current;
            % End bottom detection
            
            if beamdisp==1 ;% beam diplacement;
                aa=theta_current-angle_current;
                [xx, tt]=beamdisp(1500,1700,1000, 1500, 25, aa);
                %[xx, tt]=beamdisp(1495,1550,1000, 1550, 100, aa);
                delta_x=xx*cos(angle_current);
                delta_t=tt; 
                delta_z=-xx*sin(angle_current);
                del_k=round(delta_z/del_z);
                k=k+del_k;
            end;
%             
else
            if k<length(c)  
                
                if  p_current*c(k+1)<1 % No turning in next layer below 
                    ck=c(k); ck1=c(k+1);
                    theta_current=acos(p_current*ck1);
                    delta_x=del_z/abs(tan(theta_current));
                    delta_t=del_z/abs((sin(theta_current))*ck1);
                    delta_z=del_z;
                    k=k+1;
                    
             
             
            else % Turning point within the next layer below
                turning_below=turning_below+1;   
                %below_range(turning_below)=x_temp;
                dir=-dir;
                delta_z=0; delta_x=0; delta_t=0;
            end;% -----------------End turning point----------------
        end; % --------------------End down going wave--------------------
    end
else  %----------------Up going wave--------------------- 
    if k==1 % surface hit
        dir =1;
        surface_hits=surface_hits+1; surface_range(surface_hits)=x_temp;
        delta_x=0;
        delta_z=0;  delta_t=0;
    else  %No surface hit this time
        ck=c(k); ck1=c(k+1);
        k=k-1;
        g=(c(k+1)-c(k))/(z(k+1)-z(k));
            if p_current*c(k)<1 % No turning within next layer above
            theta_current=acos(p_current*ck1);
            delta_x=del_z/tan(theta_current);
            delta_t=del_z/(sin(theta_current)*ck1);
            delta_z=-del_z;
        else
            % Turning point within next layer above
            turning_above=turning_above+1;  
            %above_range(turning_above)=x_temp;
            dir=-dir;
            delta_z=0; delta_x=0; delta_t=0; 
            k= k+1; 
        end; % End turning point
    end;% Detection of surface hits
    
end % ---------------Updating ray position and traveltime.-----------------


x_temp=x_temp+real(delta_x);
z_temp=z_temp+delta_z;
t_temp=t_temp+delta_t;
% ---------------End updating ray position and traveltime.-----------------

% --------Determination of range to target(receiver) depth. 
if k==k_target;
    target_count=target_count+1;
    % target_count is the number of times target depth has been detected, 
    eig_range(target_count)=x_temp;
    eig_time(target_count)=t_temp;
    eig_theta(target_count)=theta_0;
    eig_angle(target_count)=dir*theta_current;
    bottom_label(target_count)=bottom_hits;
    turning_above_label(target_count)=turning_above;
    turning_below_label(target_count)=turning_below;
    surface_label(target_count)=surface_hits;
end;

length_ray=n-1;% The last point is in error  
T(n)=real(t_temp);
Z(n)=z_temp;
R(n)=x_temp;
end % n loop

