function write_file(Phen, file, premodel, nlayers, nParm, inv_parameters)
% Write a the pre files for each model ine the population
%
j=0;
[Nind, Nvar] = size(Phen);
water_d = premodel(2,2);
for j = 1:Nind

%Start writing to file:
    fid = fopen(['model_' num2str(j,'%3.2d') '.pre'],'w');

    for m=1:size(char(file{1,1}),1)
        fprintf(fid,'%s \n', char(file{1,1}(m,:)));
    end

    Geo_subsection = premodel;

    for k = 1:nParm
        idx = (k-1)*nlayers+1:k*nlayers;
        switch (inv_parameters(k,:))
            case ('ti')
                tickness = water_d + cumsum(Phen(j, idx(1:end-1)))';
                Geo_subsection(3:end-1,2) = tickness;
                Geo_subsection(end,2) = premodel(end, 2);
            case ('Vp')
                Geo_subsection(3:end,3) = Phen(j,idx)';
            case ('Vs')
                Geo_subsection(3:end,4) = Phen(j,idx)';
            case ('ap')
                Geo_subsection(3:end,5) = Phen(j,idx)';
            case ('as')
                Geo_subsection(3:end,6) = Phen(j,idx)';
            case ('de')
                Geo_subsection(3:end,7) = Phen(j,idx)';
            case ('Vw')
                Geo_subsection(2,3) = Phen(j,end);
        end
    end

    fprintf(fid, '%7d %8d %8d %8d %9.3f %9.1f %9d \n', Geo_subsection(1,:));
    
    for k = 2:nlayers+1
    
    fprintf(fid, '%7d %8.2f %8.2f %8.2f %9.2f %9.2f %9.2d \n', Geo_subsection(k,:));
    end
    fprintf(fid, '%7d %8.1g %8.2f %8.2f %9.2f %9.2f %9.2d \n', Geo_subsection(end,:));
    
    
%     fprintf(fid, '%7d %8d %8d %8d %9.3f %9.1f %9d \n', Geo_subsection(1,:));
%     fprintf(fid, '%7d %8.2d %8d %8d %9.3f %9.1f %9d \n', Geo_subsection(2,:));
%     fprintf(fid, '%7d %8.2f %8.2f %8.2f %9.2f %9.2f %9.2d \n', Geo_subsection(3,:));
%     fprintf(fid, '%7d %8.2f %8.2f %8.2f %9.2f %9.2f %9.2d \n', Geo_subsection(4,:));
%     fprintf(fid, '%7d %8.1g %8.2f %8.2f %9.2f %9.2f %9.2d \n', Geo_subsection(5,:));
    
    fseek(fid, 0, 1);
% 
%     fprintf(fid,'**  RECEIVER SUBSECTION ***\n     %s     %s     %s',...
%                 OSIPRE.rec_depth, OSIPRE.depth_intertr, OSIPRE.rec_range);
%     fprintf(fid,'     %s \n          %s          %s \n',...
%                 OSIPRE.rec_offset, OSIPRE.nrec_depth, OSIPRE.nrec_offset);
%     fprintf(fid,'**  SOURCE SUBSECTION ***\n     %s     %s     %s \n          %s \n',...
%             OSIPRE.src_depth, OSIPRE.src_rad, OSIPRE.srce_stre,OSIPRE.src_type);
%     
%     for m=1:size(char(file{2,1}),1)
%         fprintf(fid,'%s\n', char(file{2,1}(m,:)));
%     end
%     fprintf(fid,'%s', char(file{3,1}));
%     fprintf(fid,'%s     %s \n     %s \n', OSIPRE.time_upper, OSIPRE.time_samp, OSIPRE.max_center_freq);
%     
%     for m=1:size(char(file{4,1}),1)
%         fprintf(fid,'%s\n', char(file{4,1}(m,:)));
%     end
     for m = 1:size(file{2},1)
         fprintf(fid,'%s\n', char(file{2}(m,:)));
     end

fclose('all');
end

    