function NewChrom = xovermulti(Chrom, Px, selected, nXpoints)
% Perform multipoint crossover with nXpoints crossover points.


Chrom = Chrom(selected,:);
[Nind,Lind] = size(Chrom);
NewChrom = zeros(Nind,Lind);


if nargin < 4, Rs = 2; end

Xops = floor(Nind/2);
DoCross = rand(Xops,1) < Px;
odd = 1:2:Nind-1;
even = 2:2:Nind;

% Compute the effective length of each chromosome pair
Mask = DoCross*ones(1,Lind);
Mask = cumsum(Mask')';

% Compute cross sites for each pair of individuals, according to their
% effective length and Px (two equal cross sites mean no crossover)
%xsites(:, 1) = Mask(:, Lind);


for j=1:Xops                                            % Generete all 
    Xsites(j,:) = randsample(Lind-1,nXpoints)';         % the crossoverpoints needed, 
end                                                     % stored in a matrix
Xsites = sort(Xsites,2);                                 % and sort them

% Express cross sites in terms of a 0-1 mask
a = Xsites(:,ones(1,Lind)) < Mask;                  
for i=2:size(Xsites,2)
    a = a ==(Xsites(:,i*ones(1,Lind)) < Mask);
end
Mask = a;

% Perform crossover
NewChrom(odd,:) = (Chrom(odd,:).* Mask) + (Chrom(even,:).*(~Mask));
NewChrom(even,:) = (Chrom(odd,:).*(~Mask)) + (Chrom(even,:).*Mask);

% If the number of individuals is odd, the last individual cannot be mated
% but must be included in the new population
if rem(Nind,2),
  NewChrom(Nind,:)=OldChrom(Nind,:);

end
